require "prefabutil"

local prefabs =
{
    "collapse_small",
}

local assets =
{
	Asset("ANIM", "anim/dragonfly_furnace.zip"),
	Asset("ATLAS", "images/inventoryimages/dragonfly_furnace.xml"),
	Asset("ATLAS", "minimap/dragonfly_furnace.xml" ),
}

local function getstatus(inst)
    return "HIGH"
end

local function onworkfinished(inst)
    inst.components.lootdropper:DropLoot()
    local fx = SpawnPrefab("collapse_small")
    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    --fx:SetMaterial("metal")
    inst:Remove()
end

local function onworked(inst)
    if inst._task2 ~= nil then
    inst._task2:Cancel()
    inst._task2 = nil
    inst.SoundEmitter:PlaySound("dontstarve/common/sound/dragonfly_furnace/fire_LP", "loop")
    if inst._task1 ~= nil then
    inst._task1:Cancel()
    inst._task1 = nil
    end
end
    inst.AnimState:PlayAnimation("hi_hit")
    inst.AnimState:PushAnimation("hi")
end

local function BuiltTimeLine1(inst)
    inst._task1 = nil
    inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")
end

local function BuiltTimeLine2(inst)
    inst._task2 = nil
    inst.SoundEmitter:PlaySound("dontstarve/common/dragonfly_furnace/light")
    inst.SoundEmitter:PlaySound("dontstarve/common/sound/dragonfly_furnace/fire_LP", "loop")
end

local function onbuilt(inst)
    inst.AnimState:PlayAnimation("place")
    inst.AnimState:PushAnimation("hi_pre", false)
    inst.AnimState:PushAnimation("hi")
    inst.SoundEmitter:KillSound("loop")
    inst.SoundEmitter:PlaySound("dontstarve/common/sound/dragonfly_furnace/place")
    if inst._task2 ~= nil then
    inst._task2:Cancel()
    if inst._task1 ~= nil then
    inst._task1:Cancel()
    end
end
    inst._task1 = inst:DoTaskInTime(30 * FRAMES, BuiltTimeLine1)
    inst._task2 = inst:DoTaskInTime(40 * FRAMES, BuiltTimeLine2)
end

local function fn()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddLight()

    MakeObstaclePhysics(inst, .5)

    local minimap = inst.entity:AddMiniMapEntity()
    minimap:SetIcon( "dragonfly_furnace.tex" )

    inst.Light:Enable(true)
    inst.Light:SetRadius(1.0)
    inst.Light:SetFalloff(.9)
    inst.Light:SetIntensity(0.5)
    inst.Light:SetColour(235 / 255, 121 / 255, 12 / 255)

    inst.AnimState:SetBank("dragonfly_furnace")
    inst.AnimState:SetBuild("dragonfly_furnace")
    inst.AnimState:PlayAnimation("hi", true)
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
    inst.AnimState:SetLightOverride(0.4)

    inst:AddTag("structure")

    inst:AddTag("cooker")

    inst:AddTag("HASHEATER")

    inst.SoundEmitter:PlaySound("dontstarve/common/together/dragonfly_furnace/fire_LP", "loop")

    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(6)
    inst.components.workable:SetOnFinishCallback(onworkfinished)
    inst.components.workable:SetOnWorkCallback(onworked)

    inst:AddComponent("cooker")
    inst:AddComponent("lootdropper")

    inst:AddComponent("inspectable")
    inst.components.inspectable.getstatus = getstatus

    inst:AddComponent("heater")
    inst.components.heater.heat = 115

    inst:ListenForEvent("onbuilt", onbuilt)


    return inst
end

return Prefab("dragonfly_furnace", fn, assets, prefabs),
       MakePlacer("dragonfly_furnace_placer", "dragonfly_furnace", "dragonfly_furnace", "idle")
